//===========================================================================//
// Rotina da Impresso do Bloqueto Bancrio                                  //
//                                                                           //
// Parmetros: mCDBC - Cdigo do Banco Portador Numrico   3                 //
//             mDVBC - Dgito do Banco Portador Caracter   1                 //
//             mNMBC - Nome do Banco Portador   Caracter   15                //
//             mNMAG - Nmero da Agncia        Numrico   4                 //
//             mDVAG - Dgito da Agncia        Caracter   1                 //
//             mNMCT - Nmero da Conta          Numrico   8                 //
//             mDVCT - Dgito da Conta          Caracter   1                 //
//             mCTCB - Carteira de Cobrana     Numrico   3                 //
//             mEPTT - Espcie do Ttulo        Caracter   2                 //
//             mCDPF - Cdigo Convnio/Prefixo  Numrico   6                 //
//             mCDNN - Nosso Nmero             Numrico   8                 //
//             mNMDC - Nmero do Documento      Numrico   6                 //
//             mVLDC - Valor do Documento       Numrico  12,2               //
//             mDTVC - Data de Vencimento       Data                         //
//             aLNIT - Instrues               Array(7)  70 ou Caracter 70  //
//             mNMCD - Nome do Cedente          Caracter  50                 //
//             mNMSC - Nome do Sacado           Caracter  50                 //
//             mEDSC - Endereo do Sacado       Caracter  50                 //
//             mBRSC - Bairro do Sacado         Caracter  20                 //
//             mCDSC - Cidade do Sacado         Caracter  20                 //
//             mUFSC - Estado do Sacado         Caracter   2                 //
//             mCPSC - N C.E.P. do Sacado      Caracter   9                 //
//             mCGSC - N C.G.C. do Sacado      Caracter  14                 //
//===========================================================================//
#include "common.ch"
function IMP_BLQLAS(mCDBC,mDVBC,mNMBC,mNMAG,mDVAG,mNMCT,mDVCT,mCTCB,mEPTT,mCDPF,mCDNN,mNMDC,mVLDC,mDTVC,aLNIT,mNMCD,mNMSC,mEDSC,mBRSC,mCDSC,mUFSC,mCPSC,mCGSC)
local mLCPG,mNSNM,mDGNN,mCPLV,mCDBR,mDGCB,mRNCB,mFTVC,mC1RN,mC2RN,mC3RN,mC4RN,mC5RN
local mTPMD:="9"
local mDTBS:=ctod("07/10/1997")
mCDBC:=strzero(mCDBC,3)
mNMAG:=strzero(mNMAG,4)
if mCDBC=="001"       // Brasil
   mLCPG:="PAGVEL EM QUALQUER BANCO AT O VENCIMENTO"
   mNMCT:=strzero(mNMCT,8)
   mCTCB:=strzero(mCTCB,2)
   mCDPF:=alltrim(str(mCDPF))
   mCDNN:=strzero(mCDNN,iif(len(mCDPF)==4,7,5))
elseif mCDBC=="033"  // Banespa
   mLCPG:="PAGVEL EM QUALQUER BANCO AT O VENCIMENTO"
   mNMCT:=strzero(mNMCT,7)
   mCTCB:=strzero(mCTCB,3)
   mCDNN:=strzero(mCDNN,7)
elseif mCDBC=="237"  // Bradesco
   mLCPG:="PAGVEL EM QUALQUER BANCO AT O VENCIMENTO"
   mNMCT:=strzero(mNMCT,7)
   mCTCB:=strzero(mCTCB,3)
   mCDNN:=strzero(mCDNN,7)
elseif mCDBC=="341"  // Ita
   mLCPG:="PAGVEL EM QUALQUER BANCO AT O VENCIMENTO. APS, SOMENTE NO ITA OU BANERJ"
   mNMCT:=strzero(mNMCT,5)
   mCTCB:=strzero(mCTCB,3)
   mCDNN:=strzero(mCDNN,8)
elseif mCDBC=="422"  // Safra
   mLCPG:="PAGVEL EM QUALQUER BANCO AT O VENCIMENTO"
   mNMCT:=strzero(mNMCT,8)
   mCTCB:=strzero(mCTCB,1)
   mCDNN:=strzero(mCDNN,8)
endif
mNMDC:=str(mNMDC,6)
mFTVC:=strzero(mDTVC-mDTBS,4)
mVLDC:=strzero(mVLDC*100,10)
mDTVC:=dtoc(mDTVC)
aLNIT:=iif(ischaracter(aLNIT),{aLNIT,"","","","","",""},aLNIT)
//
// Monta Nosso Nmero (p/ Banco)
//
if mCDBC=="001"      // Brasil
   mDGNN:=blq_dg11(mCDBC,9,FALSE,mCDPF+mCDNN)
   mNSNM:=transform(mCDPF+mCDNN,"@R 99.999.999.999")+"-"+mDGNN
elseif mCDBC=="033"  // Banespa
   mDGNN:=blq_dges(mCDBC,FALSE,mNMAG+mCDNN)
   mNSNM:=mNMAG+" "+mCDNN+" "+mDGNN
elseif mCDBC=="237"  // Bradesco
   mDGNN:=blq_dg11(mCDBC,7,FALSE,mCTCB+mNMAG+mCDNN)
   mNSNM:=mCTCB+"/"+mNMAG+"/"+mCDNN+"-"+mDGNN
elseif mCDBC=="341"  // Ita
   mDGNN:=blq_dg10(mCDBC,mNMAG+mNMCT+mCTCB+mCDNN)
   mNSNM:=mCTCB+"/"+mCDNN+"-"+mDGNN
elseif mCDBC=="422"  // Safra
   mDGNN:=blq_dg11(mCDBC,9,FALSE,mCDNN)
   mNSNM:=mNMAG+"."+mCDNN+"-"+mDGNN
endif
//
// Monta Campo Livre do Cdigo de Barras e Linha Digitvel (p/ Banco)
//
if mCDBC=="001"      // Brasil
   mCPLV:=mCDPF+mCDNN+mNMAG+mNMCT+mCTCB
elseif mCDBC=="033"  // Banespa
   mCPLV:=mNMAG+mNMCT+mCDNN+"00"+"033"
   mCPLV+=blq_dg10(mCPLV)
   mCPLV+=blq_dg11(mCDBC,7,FALSE,mCPLV)
elseif mCDBC=="237"  // Bradesco
   mCPLV:=mNMAG+substr(mCTCB,2,2)+mNMAG+mCDNN+mNMCT+"0"
elseif mCDBC=="341"  // Ita
   mCPLV:=mCTCB+mCDNN+mDGNN+mNMAG+mNMCT+mDVCT+"000"
elseif mCDBC=="422"  // Safra
   mCPLV:="7"+mNMAG+mNMCT+mDVCT+mCDNN+mDGNN+"2"
endif
//
// Monta Cdigo de Barras (p/ Banco)
//
mDGCB:=blq_dg11(mCDBC,9,TRUE,mCDBC+mTPMD+mFTVC+mVLDC+mCPLV)
mCDBR:=mCDBC+mTPMD+mDGCB+mFTVC+mVLDC+mCPLV
//
// Monta Representao Nmerica do Cdigo de Barras
//
mC1RN:=mCDBC+mTPMD+substr(mCPLV,1,5)
mC1RN+=blq_dg10(mCDBC,mC1RN)
mC2RN:=substr(mCPLV,6,10)
mC2RN+=blq_dg10(mCDBC,mC2RN)
mC3RN:=substr(mCPLV,16,20)
mC3RN+=blq_dg10(mCDBC,mC3RN)
mC4RN:=mDGCB
mC5RN:=mFTVC+strzero(val(mVLDC),10)
mRNCB:=substr(mC1RN,1,5)+"."+substr(mC1RN,6)+" "+substr(mC2RN,1,5)+"."+substr(mC2RN,6)+" "+substr(mC3RN,1,5)+"."+substr(mC3RN,6)+"  "+mC4RN+"  "+mC5RN
//
// Emite o Bloqueto
//
set printer to LPT1
set device to PRINTER
setprc(0,0)
@ 00,00 say blq_masc()
//@ 00,00 say blq_marca()
@ 00,00 say blq_logo(mCDBC,mDVBC,mNMBC)
@ 00,00 say blq_bar25i(mCDBR)
@ 00,00 say blq_dados(mLCPG,mDTVC,mNMCD,mNMAG,mNMCT,mDVCT,mNMDC,mEPTT,mNSNM,mCTCB,mVLDC,aLNIT,mNMSC,mEDSC,mBRSC,mCDSC,mUFSC,mCPSC,mCGSC,mRNCB)
@ 00,00 say "E"
set device to SCREEN
set printer to
return TRUE
//===========================================================================//
//                                                                           //
// Retorna Dgito de Controle Mdulo 10                                      //
//                                                                           //
//===========================================================================//
static function BLQ_DG10(mCDBC,mNMOG)
local mVLDG,mSMMD,mCTDG,mRSDV,mDCMD
mSMMD:=0
for mCTDG:=1 to len(mNMOG)
   mVLDG:=val(substr(mNMOG,len(mNMOG)-mCTDG+1,1))*iif(mod(mCTDG,2)==0,1,2)
   mSMMD+=mVLDG-iif(mVLDG>9,9,0)
endfor
mRSDV:=mod(mSMMD,10)
mDCMD:=iif(mRSDV==0,"0",str(10-mRSDV,1))
return mDCMD
//===========================================================================//
//                                                                           //
// Retorna Dgito de Controle Mdulo 11 (p/ Banco)                           //
//                                                                           //
//===========================================================================//
static function BLQ_DG11(mCDBC,mBSDG,mFGCB,mNMOG)
local mSMMD,mCTDG,mSQMP,mRSDV,mDCMD
default mFGCB to FALSE
mSMMD:=0
mSQMP:=2
for mCTDG:=1 to len(mNMOG)
   mSMMD+=val(substr(mNMOG,len(mNMOG)-mCTDG+1,1))*(mSQMP)
   mSQMP:=iif(mSQMP==mBSDG,2,mSQMP+1)
endfor
mRSDV:=mod(mSMMD,11)
if mCDBC=="001"      // Brasil
   mDCMD:=iif(mRSDV==0,"0",iif(mRSDV==1,"X",str(11-mRSDV,1)))
elseif mCDBC=="033"  // Banespa
   mDCMD:=iif(mRSDV==0,"0",iif(mRSDV==1,"X",str(11-mRSDV,1)))
elseif mCDBC=="237"  // Bradesco
   if mFGCB
      mDCMD:=iif(mRSDV==11 .or. mRSDV==10 .or. mRSDV==1,"1",str(11-mRSDV,1))
   else
      mDCMD:=iif(mRSDV==0,"0",iif(mRSDV==1,"P",str(11-mRSDV,1)))
   endif
elseif mCDBC=="341"  // Ita
   mDCMD:=iif(mRSDV==11,"1",str(11-mRSDV,1))
elseif mCDBC=="422"  // Safra
   mDCMD:=iif(mRSDV==0,"1",iif(mRSDV==1,"0",str(11-mRSDV,1)))
endif
return mDCMD
//===========================================================================//
//                                                                           //
// Retorna Dgito de Controle Mdulo Especial                                //
//                                                                           //
//===========================================================================//
static function BLQ_DGES(mCDBC,mNMOG)
local mVLDG,mSMMD,mCTDG,mSQMP,mRSDV,mDCMD
if mCDBC=="033"  // Banespa
   mSMMD:=0
   mSQMP:=3
   for mCTDG:=1 to len(mNMOG)
      mVLDG:=val(substr(mNMOG,len(mNMOG)-mCTDG+1,1))*(mSQMP)
      mSMMD+=mVLDG-(int(mVLDG/10)*10)
      mSQMP:=iif(mSQMP==3,7,iif(mSQMP==7,9,iif(mSQMP==9,1,3)))
   endfor
   mRSDV:=mSMMD-(int(mSMMD/10)*10)
   mDCMD:=iif(mRSDV==0,0,10-mRSDV)
endif
return mDCMD
//===========================================================================//
//                                                                           //
// Monta a Mscara do Boleto                                                 //
//                                                                           //
//===========================================================================//
static function BLQ_MASC()
local mDDMC
mDDMC:="E"
mDDMC+="&l0L"
mDDMC+="&l1H"
mDDMC+="&l26a8d2E"
mDDMC+="&l0o2E"
mDDMC+="*p45X*p70Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p176.8Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p248.8Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p328.0Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p400.0Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p756.4Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p931.6Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p1192.0Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p1298.8Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p1370.8Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p1450.0Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p1522.0Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p1878.4Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p2053.6Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p2356.0Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p2462.8Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p2534.8Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p2614.0Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p2686.0Y*c1B*c2280A*c0P"
mDDMC+="*p45X*p3042.4Y*c3B*c2280A*c0P"
mDDMC+="*p45X*p3217.6Y*c3B*c2280A*c0P"
mDDMC+="*p1645X*p472Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p1594Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p2758Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p544Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p1666Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p2830Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p616Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p1738Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p2902Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p688Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p1810Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p2974Y*c1B*c680A*c0P"
mDDMC+="*p1645X*p70Y*c687B*c1A*c0P"
mDDMC+="*p1645X*p1192Y*c687B*c1A*c0P"
mDDMC+="*p1645X*p2356Y*c687B*c1A*c0P"
mDDMC+="*p451X*p248.8Y*c152B*c1A*c0P"
mDDMC+="*p451X*p1370.8Y*c152B*c1A*c0P"
mDDMC+="*p451X*p2534.8Y*c152B*c1A*c0P"
mDDMC+="*p793X*p248.8Y*c80B*c1A*c0P"
mDDMC+="*p793X*p1370.8Y*c80B*c1A*c0P"
mDDMC+="*p793X*p2534.8Y*c80B*c1A*c0P"
mDDMC+="*p1033X*p248.8Y*c80B*c1A*c0P"
mDDMC+="*p1033X*p1370.8Y*c80B*c1A*c0P"
mDDMC+="*p1033X*p2534.8Y*c80B*c1A*c0P"
mDDMC+="*p1261X*p248.8Y*c152B*c1A*c0P"
mDDMC+="*p1261X*p1370.8Y*c152B*c1A*c0P"
mDDMC+="*p1261X*p2534.8Y*c152B*c1A*c0P"
mDDMC+="*p622X*p328Y*c72B*c1A*c0P"
mDDMC+="*p622X*p1450Y*c72B*c1A*c0P"
mDDMC+="*p622X*p2614Y*c72B*c1A*c0P"
mDDMC+="*p769X*p328Y*c72B*c1A*c0P"
mDDMC+="*p769X*p1450Y*c72B*c1A*c0P"
mDDMC+="*p769X*p2614Y*c72B*c1A*c0P"
// Campos Achurados
mDDMC+="*p1647X*p72Y*c104B*c675A*c15G*c2P"
mDDMC+="*p1647X*p1194Y*c104B*c675A*c15G*c2P"
mDDMC+="*p1647X*p2358Y*c104B*c675A*c15G*c2P"
mDDMC+="*p1647X*p330Y*c70B*c675A*c15G*c2P"
mDDMC+="*p1647X*p1452Y*c70B*c675A*c15G*c2P"
mDDMC+="*p1647X*p2616Y*c70B*c675A*c15G*c2P"
mDDMC+="*p1647X*p690Y*c68B*c675A*c15G*c2P"
mDDMC+="*p1647X*p1812Y*c68B*c675A*c15G*c2P"
mDDMC+="*p1647X*p2976Y*c68B*c675A*c15G*c2P"
// Descrio dos Campos
mDDMC+="(0N(s3t1b0s12.00v10.00h0P*p1824.00X*p56.40YRecibo do Sacado"
mDDMC+="(0N(s3t1b0s12.00v10.00h0P*p1872.00X*p1178.40YFicha de Caixa"
mDDMC+="(12U(s24H(s5B(s4102T"
mDDMC+="*p1X*p1095Y"+replicate("-",180)
mDDMC+="*p1X*p2259Y"+replicate("-",180)
mDDMC+="*p45.60X*p98.40YLocal de Pagamento"
mDDMC+="*p45.60X*p1220.40YLocal de Pagamento"
mDDMC+="*p45.60X*p2384.40YLocal de Pagamento"
mDDMC+="*p1656.00X*p98.40YVencimento"
mDDMC+="*p1656.00X*p1220.40YVencimento"
mDDMC+="*p1656.00X*p2384.40YVencimento"
mDDMC+="*p45.60X*p205.20YCedente"
mDDMC+="*p45.60X*p1327.20YCedente"
mDDMC+="*p45.60X*p2491.20YCedente"
mDDMC+="*p45.60X*p205.20YCedente"
mDDMC+="*p1656.00X*p205.20YAgncia/Cdigo Cedente"
mDDMC+="*p1656.00X*p1327.20YAgncia/Cdigo Cedente"
mDDMC+="*p1656.00X*p2491.20YAgncia/Cdigo Cedente"
mDDMC+="*p45.60X*p277.20YData do Documento"
mDDMC+="*p45.60X*p1399.20YData do Documento"
mDDMC+="*p45.60X*p2563.20YData do Documento"
mDDMC+="*p462.00X*p277.20YNmero do Documento"
mDDMC+="*p462.00X*p1399.20YNmero do Documento"
mDDMC+="*p462.00X*p2563.20YNmero do Documento"
mDDMC+="*p804.00X*p277.20YEspcie Doc."
mDDMC+="*p804.00X*p1399.20YEspcie Doc."
mDDMC+="*p804.00X*p2563.20YEspcie Doc."
mDDMC+="*p1044.00X*p277.20YAceite"
mDDMC+="*p1044.00X*p1399.20YAceite"
mDDMC+="*p1044.00X*p2563.20YAceite"
mDDMC+="*p1272.00X*p277.20YData do Processamento"
mDDMC+="*p1272.00X*p1399.20YData do Processamento"
mDDMC+="*p1272.00X*p2563.20YData do Processamento"
mDDMC+="*p1656.00X*p277.20YNosso Nmero"
mDDMC+="*p1656.00X*p1399.20YNosso Nmero"
mDDMC+="*p1656.00X*p2563.20YNosso Nmero"
mDDMC+="*p45.60X*p356.40YUso do Banco"
mDDMC+="*p45.60X*p1478.40YUso do Banco"
mDDMC+="*p45.60X*p2642.40YUso do Banco"
mDDMC+="*p462.00X*p356.40YCarteira"
mDDMC+="*p462.00X*p1478.40YCarteira"
mDDMC+="*p462.00X*p2642.40YCarteira"
mDDMC+="*p633.60X*p356.40YEspcie"
mDDMC+="*p633.60X*p1478.40YEspcie"
mDDMC+="*p633.60X*p2642.40YEspcie"
mDDMC+="*p780.00X*p356.40YQuantidade"
mDDMC+="*p780.00X*p1478.40YQuantidade"
mDDMC+="*p780.00X*p2642.40YQuantidade"
mDDMC+="*p1272.00X*p356.40Y(x) Valor"
mDDMC+="*p1272.00X*p1478.40Y(x) Valor"
mDDMC+="*p1272.00X*p2642.40Y(x) Valor"
mDDMC+="*p1656.00X*p356.40Y( = ) Valor do Documento"
mDDMC+="*p1656.00X*p1478.40Y( = ) Valor do Documento"
mDDMC+="*p1656.00X*p2642.40Y( = ) Valor do Documento"
mDDMC+="*p45.60X*p428.40YInstrues (Todas informaes deste bloqueto so de exclusiva responsabilidade do cedente.)"
mDDMC+="*p45.60X*p1550.40YInstrues (Todas informaes deste bloqueto so de exclusiva responsabilidade do cedente.)"
mDDMC+="*p45.60X*p2714.40YInstrues (Todas informaes deste bloqueto so de exclusiva responsabilidade do cedente.)"
mDDMC+="*p1656.00X*p428.40Y(-) Desconto/Abatimento"
mDDMC+="*p1656.00X*p1550.40Y(-) Desconto/Abatimento"
mDDMC+="*p1656.00X*p2714.40Y(-) Desconto/Abatimento"
mDDMC+="*p1656.00X*p572.40Y( + ) Mora/Multa"
mDDMC+="*p1656.00X*p1694.40Y( + ) Mora/Multa"
mDDMC+="*p1656.00X*p2858.40Y( + ) Mora/Multa"
mDDMC+="*p1656.00X*p716.40Y( = ) Valor Cobrado"
mDDMC+="*p1656.00X*p1838.40Y( = ) Valor Cobrado"
mDDMC+="*p1656.00X*p3002.40Y( = ) Valor Cobrado"
mDDMC+="*p45.60X*p784.80YSacado"
mDDMC+="*p45.60X*p1906.80YSacado"
mDDMC+="*p45.60X*p3070.80YSacado"
mDDMC+="*p45.60X*p918.00YSacador/Avalista"
mDDMC+="*p45.60X*p2040.00YSacador/Avalista"
mDDMC+="*p45.60X*p3204.00YSacador/Avalista"
mDDMC+="*p1830.00X*p918.00YCdigo de Baixa"
mDDMC+="*p1830.00X*p2040.00YCdigo de Baixa"
mDDMC+="*p1830.00X*p3204.00YCdigo de Baixa"
mDDMC+="*p45.60X*p960.00YRecebimento atravs do cheque nmero                        do banco"
mDDMC+="*p45.60X*p984.00YEsta quitao s ter validade aps o pagamento do cheque pelo"
mDDMC+="*p45.60X*p1008.00Ybanco sacado."
mDDMC+="*p1656.00X*p960.00YAutenticao mecnica"
mDDMC+="*p1656.00X*p2082.00YAutenticao mecnica"
mDDMC+="*p1560.00X*p3246.00YAutenticao mecnica - Ficha de Compensao"
return mDDMC
//===========================================================================//
//                                                                           //
// Monta a Marca D'gua do Boleto                                            //
//                                                                           //
//===========================================================================//
static function BLQ_MARCA()
local mFLHD,mNBRD,mNBBK,mTXBF,mDDMC
mDDMC:=""
mFLHD:=fopen("MASC\BLQMARCA.MSC",2)
if ferror()==0
   mNBBK:=512
   mNBRD:=mNBBK
   mTXBF:=space(mNBBK)
   do while mNBRD==mNBBK
      mNBRD:=fread(mFLHD,@mTXBF,mNBBK)
      mDDMC+=mTXBF
   enddo
   fclose(mFLHD)
endif
return mDDMC
//===========================================================================//
//                                                                           //
// Monta Logotipo do Banco (p/ Banco)                                        //
//                                                                           //
//===========================================================================//
static function BLQ_LOGO(mCDBC,mDVBC,mNMBC)
local mFLHD,mNBRD,mNBBK,mTXBF,mDDLG
mDDLG:=""
mFLHD:=fopen("MASC\BLQLG"+mCDBC+".MSC",2)
if ferror()==0
   mNBBK:=512
   mNBRD:=mNBBK
   mTXBF:=space(mNBBK)
   do while mNBRD==mNBBK
      mNBRD:=fread(mFLHD,@mTXBF,mNBBK)
      mDDLG+=mTXBF
   enddo
   fclose(mFLHD)
else
   mDDLG+="*p540X*p0Y*c70B*c5A*c0P"
   mDDLG+="*p860X*p0Y*c70B*c5A*c0P"
   mDDLG+="(0N(s3t3b0s10v6h0P*p50X*p60Y"+mNMBC
   mDDLG+="(0N(s3t1b0s4v5h0P*p550X*p60Y"+mCDBC+"-"+mDVBC
   mDDLG+="*p540X*p1122Y*c70B*c5A*c0P"
   mDDLG+="*p860X*p1122Y*c70B*c5A*c0P"
   mDDLG+="(0N(s3t3b0s10v6h0P*p50X*p1182Y"+mNMBC
   mDDLG+="(0N(s3t1b0s4v5h0P*p550X*p1182Y"+mCDBC+"-"+mDVBC
   mDDLG+="*p540X*p2286Y*c70B*c5A*c0P"
   mDDLG+="*p860X*p2286Y*c70B*c5A*c0P"
   mDDLG+="(0N(s3t3b0s10v6h0P*p50X*p2346Y"+mNMBC
   mDDLG+="(0N(s3t1b0s4v5h0P*p550X*p2346Y"+mCDBC+"-"+mDVBC
endif
return mDDLG
//===========================================================================//
//                                                                           //
// Monta o Cdigo de Barras (Formato e rea de Impresso)                    //
//                                                                           //
//===========================================================================//
static function BLQ_BAR25I(mCDBR)
local mTXBR,aDDBR[100],mTXIN,mTXFN,mCTGR
mTXIN:="*p50X*p3230Y*c145B*p+0X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
mTXFN:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X"
aDDBR[01]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[02]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[03]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[04]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[05]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[06]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[07]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[08]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X"
aDDBR[09]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[10]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[11]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[12]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[13]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[14]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[15]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[16]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[17]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[18]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X"
aDDBR[19]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[20]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[21]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[22]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[23]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[24]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[25]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[26]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[27]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[28]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X"
aDDBR[29]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[30]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[31]:="*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[32]:="*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[33]:="*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[34]:="*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[35]:="*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[36]:="*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[37]:="*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[38]:="*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X"
aDDBR[39]:="*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[40]:="*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[41]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[42]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[43]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[44]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[45]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[46]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[47]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[48]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X"
aDDBR[49]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[50]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[51]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[52]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[53]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[54]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[55]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[56]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[57]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[58]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X"
aDDBR[59]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[60]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[61]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[62]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[63]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[64]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[65]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[66]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[67]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[68]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X"
aDDBR[69]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[70]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[71]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[72]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[73]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[74]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[75]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+9X"
aDDBR[76]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[77]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c9A*c0P*p+9X*p+3X"
aDDBR[78]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+9X"
aDDBR[79]:="*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[80]:="*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c9A*c0P*p+9X*p+3X"
aDDBR[81]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[82]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[83]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[84]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[85]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[86]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[87]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[88]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X"
aDDBR[89]:="*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[90]:="*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[91]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[92]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[93]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[94]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[95]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X"
aDDBR[96]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[97]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X"
aDDBR[98]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+9X"
aDDBR[99]:="*c3A*c0P*p+3X*p+9X*c9A*c0P*p+9X*p+3X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
aDDBR[100]:="*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X*c9A*c0P*p+9X*p+9X*c3A*c0P*p+3X*p+3X"
mTXBR:=mTXIN
for mCTGR:=1 to len(mCDBR) step 2
   mTXBR+=aDDBR[val(substr(mCDBR,mCTGR,2))+1]
endfor
mTXBR+=mTXFN
return mTXBR
//===========================================================================//
//                                                                           //
// Monta a rea de Dados do Boleto                                           //
//                                                                           //
//===========================================================================//
static function BLQ_DADOS(mLCPG,mDTVC,mNMCD,mNMAG,mNMCT,mDVCT,mNMDC,mEPTT,mNSNM,mCTCB,mVLDC,aLNIT,mNMSC,mEDSC,mBRSC,mCDSC,mUFSC,mCPSC,mCGSC,mRNCB)
local mDDBQ
//
// Primeira parte do bloquete -> RECIBO DO SACADO
//
mDDBQ:="(12U(s16901t1b0s10.00v14.00h0P*p55X*p150Y"+mLCPG
mDDBQ+="(12U(s16901t1b1s10.00v10.00h0P*p1850X*p150Y"+mDTVC
mDDBQ+="(12U(s16901t3b0s10.00v14.00h0P*p55X*p240Y"+mNMCD
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1870X*p240Y"+mNMAG+"/"+mNMCT+"-"+mDVCT
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p320Y"+dtoc(date())
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p480X*p320Y"+mNMDC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p875X*p320Y"+mEPTT
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1140X*p320YN"
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1870X*p320Y"+mNSNM
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p480X*p390Y"+mCTCB
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p650X*p390YR$"
mDDBQ+="(12U(s16901t1b1s10.00v10.00h0P*p1870X*p380Y"+transform(round(val(mVLDC)/100,2),"@ZE 999,999,999.99")
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p470Y"+aLNIT[1]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p515Y"+aLNIT[2]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p560Y"+aLNIT[3]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p605Y"+aLNIT[4]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p650Y"+aLNIT[5]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p695Y"+aLNIT[6]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p740Y"+aLNIT[7]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p810Y"+mNMSC+"          C.G.C.: "+mCGSC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p855Y"+mEDSC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p900Y"+mCPSC+"  "+mBRSC+"  "+mCDSC+"  "+mUFSC
//
// Segunda parte do bloquete -> FICHA DE CAIXA
//
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1272Y"+mLCPG
mDDBQ+="(12U(s16901t1b1s10.00v10.00h0P*p1850X*p1272Y"+mDTVC
mDDBQ+="(12U(s16901t3b0s10.00v14.00h0P*p55X*p1362Y"+mNMCD
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1870X*p1362Y"+mNMAG+"/"+mNMCT+"-"+mDVCT
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1442Y"+dtoc(date())
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p480X*p1442Y"+mNMDC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p875X*p1442Y"+mEPTT
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1140X*p1442YN"
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1870X*p1442Y"+mNSNM
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p480X*p1512Y"+mCTCB
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p650X*p1512YR$"
mDDBQ+="(12U(s16901t1b1s10.00v10.00h0P*p1870X*p1512Y"+transform(round(val(mVLDC)/100,2),"@ZE 999,999,999.99")
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1592Y"+aLNIT[1]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1637Y"+aLNIT[2]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1682Y"+aLNIT[3]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1727Y"+aLNIT[4]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1772Y"+aLNIT[5]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1817Y"+aLNIT[6]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p1862Y"+aLNIT[7]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p1932Y"+mNMSC+"          C.G.C.: "+mCGSC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p1977Y"+mEDSC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p2022Y"+mCPSC+"  "+mBRSC+"  "+mCDSC+"  "+mUFSC
//
// Terceira parte do bloquete -> FICHA DE COMPENSAO
//
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2436Y"+mLCPG
mDDBQ+="(12U(s16901t1b1s10.00v10.00h0P*p1850X*p2436Y"+mDTVC
mDDBQ+="(12U(s16901t3b0s10.00v14.00h0P*p55X*p2526Y"+mNMCD
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1870X*p2526Y"+mNMAG+"/"+mNMCT+"-"+mDVCT
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2606Y"+dtoc(date())
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p480X*p2606Y"+mNMDC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p875X*p2606Y"+mEPTT
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1140X*p2606YN"
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p1870X*p2606Y"+mNSNM
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p480X*p2676Y"+mCTCB
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p650X*p2676YR$"
mDDBQ+="(12U(s16901t1b1s10.00v10.00h0P*p1870X*p2676Y"+transform(round(val(mVLDC)/100,2),"@ZE 999,999,999.99")
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2756Y"+aLNIT[1]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2801Y"+aLNIT[2]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2846Y"+aLNIT[3]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2891Y"+aLNIT[4]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2936Y"+aLNIT[5]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p2981Y"+aLNIT[6]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p55X*p3026Y"+aLNIT[7]
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p3096Y"+mNMSC+"          C.G.C.: "+mCGSC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p3141Y"+mEDSC
mDDBQ+="(12U(s16901t1b0s10.00v14.00h0P*p250X*p3186Y"+mCPSC+"  "+mBRSC+"  "+mCDSC+"  "+mUFSC
mDDBQ+="(s12H(s7B(s4102T*p920X*p2346Y"+mRNCB
return mDDBQ
